<html>
<head>
<title>Ogre::TangentSpaceCalc Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1TangentSpaceCalc.html">TangentSpaceCalc</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::TangentSpaceCalc Class Reference<div class="ingroups"><a class="el" href="group__Math.html">Math</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::TangentSpaceCalc" -->
<p>Class for calculating a tangent space basis.  
 <a href="classOgre_1_1TangentSpaceCalc.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>&gt;</code></p>

<p><a href="classOgre_1_1TangentSpaceCalc-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html">IndexRemap</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Information about a remapped index.  <a href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The result of having built a tangent space basis.  <a href="structOgre_1_1TangentSpaceCalc_1_1Result.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html">VertexInfo</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::pair&lt; size_t, size_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">VertexSplit</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt; <a class="el" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html">IndexRemap</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2ac32473675f968018e1dee1cbcf9cbe">IndexRemapList</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">List of indexes that were remapped (split vertices).  <a href="#a2ac32473675f968018e1dee1cbcf9cbe"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt; <a class="el" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">VertexSplit</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">VertexSplits</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a33eeb35f74cfa2d2c90ab7b138763752">TangentSpaceCalc</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#af77985c55f78fb23bb3346c0ecef4743">~TangentSpaceCalc</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#afd150caf2af93ec05fcbc836641e894a">clear</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset the calculation object.  <a href="#afd150caf2af93ec05fcbc836641e894a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#aac1530e73ac67068755e65063965fe98">setVertexData</a> (<a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *v_in)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the incoming vertex data (which will be modified)  <a href="#aac1530e73ac67068755e65063965fe98"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#aa15868f47d97e86805e75ee53ffe66a2">addIndexData</a> (<a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *i_in, <a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a> opType=<a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10da8c00ee152b44fe8000c2fd675437c087">RenderOperation::OT_TRIANGLE_LIST</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a set of index data that references the vertex data.  <a href="#aa15868f47d97e86805e75ee53ffe66a2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a637794857196e7b6bec4974b97ee5a50">setStoreParityInW</a> (bool enabled)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether to store tangent space parity in the W of a 4-component tangent or not.  <a href="#a637794857196e7b6bec4974b97ee5a50"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a00fec0ad7040d961755ad4300f848f3a">getStoreParityInW</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets whether to store tangent space parity in the W of a 4-component tangent or not.  <a href="#a00fec0ad7040d961755ad4300f848f3a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a43107313dd9e1fefb5a0f0760792ac45">setSplitMirrored</a> (bool split)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether or not to split vertices when a mirrored tangent space transition is detected (matrix parity differs).  <a href="#a43107313dd9e1fefb5a0f0760792ac45"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#ae67135b8fe3fde96af0f915bd36412cd">getSplitMirrored</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets whether or not to split vertices when a mirrored tangent space transition is detected.  <a href="#ae67135b8fe3fde96af0f915bd36412cd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a3b9ef4ec951f3a95e40697d7c6637a7d">setSplitRotated</a> (bool split)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether or not to split vertices when tangent space rotates more than 90 degrees around a vertex.  <a href="#a3b9ef4ec951f3a95e40697d7c6637a7d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a3368c291e9891b0022442d7e2e74e1c0">getSplitRotated</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether or not to split vertices when tangent space rotates more than 90 degrees around a vertex.  <a href="#a3368c291e9891b0022442d7e2e74e1c0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a57b5fd6b859dd9378bcebeb6882352d1">build</a> (<a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> targetSemantic=<a class="el" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da57d43012049b3ec7b4240b207dd029f2">VES_TANGENT</a>, unsigned short sourceTexCoordSet=0, unsigned short index=1)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Build a tangent space basis from the provided data.  <a href="#a57b5fd6b859dd9378bcebeb6882352d1"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a5aa76640242555497cf5decebb2eee97">IndexDataList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a> &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2cab27a58be8085742707d309d52a493">OpTypeList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html">VertexInfo</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#af5204c42a779f3f8a71a8f06b4000d2b">VertexInfoArray</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a80025c208b8c1dc0b5e7538f8032bffb">extendBuffers</a> (<a class="el" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">VertexSplits</a> &amp;splits)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a45ef735b4e542577a365f6788842b86a">insertTangents</a> (<a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;res, <a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> targetSemantic, unsigned short sourceTexCoordSet, unsigned short index)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#affc29e9f91980dd54526d45d23eedaf5">populateVertexArray</a> (unsigned short sourceTexCoordSet)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a16318a450378eacfcdfe19bc8b06ad78">processFaces</a> (<a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;result)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a4c50121180da61a28823d2977c38da05">calculateFaceTangentSpace</a> (const size_t *vertInd, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;tsU, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;tsV, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;tsN)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate face tangent space, U and V are weighted by UV area, N is normalised.  <a href="#a4c50121180da61a28823d2977c38da05"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a926e76d7223a2b854e76d41c51edce21">calculateAngleWeight</a> (size_t v0, size_t v1, size_t v2)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#af8fa9bc6805c21d5744f5b8249205aa9">calculateParity</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;u, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;n)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2965369008d8f05f57baf4bb0ab129b3">addFaceTangentSpaceToVertices</a> (size_t indexSet, size_t faceIndex, size_t *localVertInd, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;faceTsU, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;faceTsV, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;faceNorm, <a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;result)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#aaf104c5bfe7a899f56607897c9845a0e">normaliseVertices</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a8c6c1cd8f15dc31c59dae94de5de8842">remapIndexes</a> (<a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;res)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#ab929ed3076f728b804f2115cd5f48853">remapIndexes</a> (T *ibuf, size_t indexSet, <a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;res)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#ada66de0f26b1df7521fc8f20dbda4718">mVData</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a5aa76640242555497cf5decebb2eee97">IndexDataList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a7abe610c2dbc8256421979bc6e63ce47">mIDataList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2cab27a58be8085742707d309d52a493">OpTypeList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a3a17076d70074dabd0884b14efaed6d0">mOpTypes</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a17e748a306d6e8aa655573f425b1ee98">mSplitMirrored</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a09fcd46e2d234c9c967a394c96ed608c">mSplitRotated</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a648fd36164397e42547bd3758018245d">mStoreParityInW</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#af5204c42a779f3f8a71a8f06b4000d2b">VertexInfoArray</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a43bd62c359203f882604b685b8a71176">mVertexArray</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class for calculating a tangent space basis. </p>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00048">48</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a5aa76640242555497cf5decebb2eee97"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::IndexDataList" ref="a5aa76640242555497cf5decebb2eee97" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1IndexData.html">IndexData</a>*&gt;::type <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a5aa76640242555497cf5decebb2eee97">Ogre::TangentSpaceCalc::IndexDataList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00186">186</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2ac32473675f968018e1dee1cbcf9cbe"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::IndexRemapList" ref="a2ac32473675f968018e1dee1cbcf9cbe" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt;<a class="el" href="structOgre_1_1TangentSpaceCalc_1_1IndexRemap.html">IndexRemap</a>&gt;::type <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2ac32473675f968018e1dee1cbcf9cbe">Ogre::TangentSpaceCalc::IndexRemapList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>List of indexes that were remapped (split vertices). </p>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00071">71</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2cab27a58be8085742707d309d52a493"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::OpTypeList" ref="a2cab27a58be8085742707d309d52a493" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a>&gt;::type <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2cab27a58be8085742707d309d52a493">Ogre::TangentSpaceCalc::OpTypeList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00187">187</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="af5204c42a779f3f8a71a8f06b4000d2b"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::VertexInfoArray" ref="af5204c42a779f3f8a71a8f06b4000d2b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="structOgre_1_1TangentSpaceCalc_1_1VertexInfo.html">VertexInfo</a>&gt;::type <a class="el" href="classOgre_1_1TangentSpaceCalc.html#af5204c42a779f3f8a71a8f06b4000d2b">Ogre::TangentSpaceCalc::VertexInfoArray</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00210">210</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="af7248e9a56104604d70decacbddc24b6"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::VertexSplit" ref="af7248e9a56104604d70decacbddc24b6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::pair&lt;size_t, size_t&gt; <a class="el" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">Ogre::TangentSpaceCalc::VertexSplit</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00054">54</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="abd646b98a45056f1251b49cf34881b51"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::VertexSplits" ref="abd646b98a45056f1251b49cf34881b51" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1list.html">list</a>&lt;<a class="el" href="classOgre_1_1TangentSpaceCalc.html#af7248e9a56104604d70decacbddc24b6">VertexSplit</a>&gt;::type <a class="el" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">Ogre::TangentSpaceCalc::VertexSplits</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00073">73</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a33eeb35f74cfa2d2c90ab7b138763752"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::TangentSpaceCalc" ref="a33eeb35f74cfa2d2c90ab7b138763752" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a33eeb35f74cfa2d2c90ab7b138763752">Ogre::TangentSpaceCalc::TangentSpaceCalc</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="af77985c55f78fb23bb3346c0ecef4743"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::~TangentSpaceCalc" ref="af77985c55f78fb23bb3346c0ecef4743" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1TangentSpaceCalc.html#af77985c55f78fb23bb3346c0ecef4743">Ogre::TangentSpaceCalc::~TangentSpaceCalc</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a2965369008d8f05f57baf4bb0ab129b3"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::addFaceTangentSpaceToVertices" ref="a2965369008d8f05f57baf4bb0ab129b3" args="(size_t indexSet, size_t faceIndex, size_t *localVertInd, const Vector3 &amp;faceTsU, const Vector3 &amp;faceTsV, const Vector3 &amp;faceNorm, Result &amp;result)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2965369008d8f05f57baf4bb0ab129b3">Ogre::TangentSpaceCalc::addFaceTangentSpaceToVertices</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>indexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>faceIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t *&#160;</td>
          <td class="paramname"><em>localVertInd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>faceTsU</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>faceTsV</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>faceNorm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;&#160;</td>
          <td class="paramname"><em>result</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aa15868f47d97e86805e75ee53ffe66a2"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::addIndexData" ref="aa15868f47d97e86805e75ee53ffe66a2" args="(IndexData *i_in, RenderOperation::OperationType opType=RenderOperation::OT_TRIANGLE_LIST)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#aa15868f47d97e86805e75ee53ffe66a2">Ogre::TangentSpaceCalc::addIndexData</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&#160;</td>
          <td class="paramname"><em>i_in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a>&#160;</td>
          <td class="paramname"><em>opType</em> = <code><a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10da8c00ee152b44fe8000c2fd675437c087">RenderOperation::OT_TRIANGLE_LIST</a></code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a set of index data that references the vertex data. </p>
<p>This might be modified if there are vertex splits. </p>

</div>
</div>
<a class="anchor" id="a57b5fd6b859dd9378bcebeb6882352d1"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::build" ref="a57b5fd6b859dd9378bcebeb6882352d1" args="(VertexElementSemantic targetSemantic=VES_TANGENT, unsigned short sourceTexCoordSet=0, unsigned short index=1)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a57b5fd6b859dd9378bcebeb6882352d1">Ogre::TangentSpaceCalc::build</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>targetSemantic</em> = <code><a class="el" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da57d43012049b3ec7b4240b207dd029f2">VES_TANGENT</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>sourceTexCoordSet</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Build a tangent space basis from the provided data. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Only indexed triangle lists are allowed. Strips and fans cannot be supported because it may be necessary to split the geometry up to respect deviances in the tangent space basis better. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">targetSemantic</td><td>The semantic to store the tangents in. Defaults to the explicit tangent binding, but note that this is only usable on more modern hardware (Shader Model 2), so if you need portability with older cards you should change this to a texture coordinate binding instead. </td></tr>
    <tr><td class="paramname">sourceTexCoordSet</td><td>The texture coordinate index which should be used as the source of 2D texture coordinates, with which to calculate the tangents. </td></tr>
    <tr><td class="paramname">index</td><td>The element index, ie the texture coordinate set which should be used to store the 3D coordinates representing a tangent vector per vertex, if targetSemantic is VES_TEXTURE_COORDINATES. If this already exists, it will be overwritten. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>A structure containing the results of the tangent space build. Vertex data will always be modified but it's also possible that the index data could be adjusted. This happens when mirroring is used on a mesh, which causes the tangent space to be inverted on opposite sides of an edge. This is discontinuous, therefore the vertices have to be split along this edge, resulting in new vertices. </dd></dl>

</div>
</div>
<a class="anchor" id="a926e76d7223a2b854e76d41c51edce21"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::calculateAngleWeight" ref="a926e76d7223a2b854e76d41c51edce21" args="(size_t v0, size_t v1, size_t v2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a926e76d7223a2b854e76d41c51edce21">Ogre::TangentSpaceCalc::calculateAngleWeight</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>v0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>v1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>v2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a4c50121180da61a28823d2977c38da05"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::calculateFaceTangentSpace" ref="a4c50121180da61a28823d2977c38da05" args="(const size_t *vertInd, Vector3 &amp;tsU, Vector3 &amp;tsV, Vector3 &amp;tsN)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a4c50121180da61a28823d2977c38da05">Ogre::TangentSpaceCalc::calculateFaceTangentSpace</a> </td>
          <td>(</td>
          <td class="paramtype">const size_t *&#160;</td>
          <td class="paramname"><em>vertInd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>tsU</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>tsV</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>tsN</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculate face tangent space, U and V are weighted by UV area, N is normalised. </p>

</div>
</div>
<a class="anchor" id="af8fa9bc6805c21d5744f5b8249205aa9"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::calculateParity" ref="af8fa9bc6805c21d5744f5b8249205aa9" args="(const Vector3 &amp;u, const Vector3 &amp;v, const Vector3 &amp;n)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1TangentSpaceCalc.html#af8fa9bc6805c21d5744f5b8249205aa9">Ogre::TangentSpaceCalc::calculateParity</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>u</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="afd150caf2af93ec05fcbc836641e894a"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::clear" ref="afd150caf2af93ec05fcbc836641e894a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#afd150caf2af93ec05fcbc836641e894a">Ogre::TangentSpaceCalc::clear</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reset the calculation object. </p>

</div>
</div>
<a class="anchor" id="a80025c208b8c1dc0b5e7538f8032bffb"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::extendBuffers" ref="a80025c208b8c1dc0b5e7538f8032bffb" args="(VertexSplits &amp;splits)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a80025c208b8c1dc0b5e7538f8032bffb">Ogre::TangentSpaceCalc::extendBuffers</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#abd646b98a45056f1251b49cf34881b51">VertexSplits</a> &amp;&#160;</td>
          <td class="paramname"><em>splits</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ae67135b8fe3fde96af0f915bd36412cd"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::getSplitMirrored" ref="ae67135b8fe3fde96af0f915bd36412cd" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1TangentSpaceCalc.html#ae67135b8fe3fde96af0f915bd36412cd">Ogre::TangentSpaceCalc::getSplitMirrored</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets whether or not to split vertices when a mirrored tangent space transition is detected. </p>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00135">135</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3368c291e9891b0022442d7e2e74e1c0"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::getSplitRotated" ref="a3368c291e9891b0022442d7e2e74e1c0" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a3368c291e9891b0022442d7e2e74e1c0">Ogre::TangentSpaceCalc::getSplitRotated</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether or not to split vertices when tangent space rotates more than 90 degrees around a vertex. </p>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00155">155</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a00fec0ad7040d961755ad4300f848f3a"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::getStoreParityInW" ref="a00fec0ad7040d961755ad4300f848f3a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a00fec0ad7040d961755ad4300f848f3a">Ogre::TangentSpaceCalc::getStoreParityInW</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets whether to store tangent space parity in the W of a 4-component tangent or not. </p>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00114">114</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a45ef735b4e542577a365f6788842b86a"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::insertTangents" ref="a45ef735b4e542577a365f6788842b86a" args="(Result &amp;res, VertexElementSemantic targetSemantic, unsigned short sourceTexCoordSet, unsigned short index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a45ef735b4e542577a365f6788842b86a">Ogre::TangentSpaceCalc::insertTangents</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;&#160;</td>
          <td class="paramname"><em>res</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>targetSemantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>sourceTexCoordSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aaf104c5bfe7a899f56607897c9845a0e"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::normaliseVertices" ref="aaf104c5bfe7a899f56607897c9845a0e" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#aaf104c5bfe7a899f56607897c9845a0e">Ogre::TangentSpaceCalc::normaliseVertices</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="affc29e9f91980dd54526d45d23eedaf5"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::populateVertexArray" ref="affc29e9f91980dd54526d45d23eedaf5" args="(unsigned short sourceTexCoordSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#affc29e9f91980dd54526d45d23eedaf5">Ogre::TangentSpaceCalc::populateVertexArray</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>sourceTexCoordSet</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a16318a450378eacfcdfe19bc8b06ad78"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::processFaces" ref="a16318a450378eacfcdfe19bc8b06ad78" args="(Result &amp;result)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a16318a450378eacfcdfe19bc8b06ad78">Ogre::TangentSpaceCalc::processFaces</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;&#160;</td>
          <td class="paramname"><em>result</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a8c6c1cd8f15dc31c59dae94de5de8842"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::remapIndexes" ref="a8c6c1cd8f15dc31c59dae94de5de8842" args="(Result &amp;res)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a8c6c1cd8f15dc31c59dae94de5de8842">Ogre::TangentSpaceCalc::remapIndexes</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;&#160;</td>
          <td class="paramname"><em>res</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ab929ed3076f728b804f2115cd5f48853"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::remapIndexes" ref="ab929ed3076f728b804f2115cd5f48853" args="(T *ibuf, size_t indexSet, Result &amp;res)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a8c6c1cd8f15dc31c59dae94de5de8842">Ogre::TangentSpaceCalc::remapIndexes</a> </td>
          <td>(</td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>ibuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>indexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1TangentSpaceCalc_1_1Result.html">Result</a> &amp;&#160;</td>
          <td class="paramname"><em>res</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00229">229</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

<p>References <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00062">Ogre::TangentSpaceCalc::IndexRemap::faceIndex</a>, <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00085">Ogre::TangentSpaceCalc::Result::indexesRemapped</a>, <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00060">Ogre::TangentSpaceCalc::IndexRemap::indexSet</a>, and <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00064">Ogre::TangentSpaceCalc::IndexRemap::splitVertex</a>.</p>

</div>
</div>
<a class="anchor" id="a43107313dd9e1fefb5a0f0760792ac45"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::setSplitMirrored" ref="a43107313dd9e1fefb5a0f0760792ac45" args="(bool split)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a43107313dd9e1fefb5a0f0760792ac45">Ogre::TangentSpaceCalc::setSplitMirrored</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>split</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether or not to split vertices when a mirrored tangent space transition is detected (matrix parity differs). </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This defaults to 'off' because it's the safest option; tangents will be interpolated in all cases even if they don't agree around a vertex, so artefacts will be smoothed out. When you're using art assets of unknown quality this can avoid extra seams on the visible surface. However, if your artists are good, they will be hiding texture seams in folds of the model and thus you can turn this option on, which will prevent the results of those seams from getting smoothed into other areas, which is exactly what you want. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This option is automatically disabled if you provide any strip or fan based geometry. </dd></dl>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00130">130</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3b9ef4ec951f3a95e40697d7c6637a7d"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::setSplitRotated" ref="a3b9ef4ec951f3a95e40697d7c6637a7d" args="(bool split)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a3b9ef4ec951f3a95e40697d7c6637a7d">Ogre::TangentSpaceCalc::setSplitRotated</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>split</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether or not to split vertices when tangent space rotates more than 90 degrees around a vertex. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This defaults to 'off' because it's the safest option; tangents will be interpolated in all cases even if they don't agree around a vertex, so artefacts will be smoothed out. When you're using art assets of unknown quality this can avoid extra seams on the visible surface. However, if your artists are good, they will be hiding texture inconsistencies in folds of the model and thus you can turn this option on, which will prevent the results of those seams from getting smoothed into other areas, which is exactly what you want. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This option is automatically disabled if you provide any strip or fan based geometry. </dd></dl>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00151">151</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a637794857196e7b6bec4974b97ee5a50"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::setStoreParityInW" ref="a637794857196e7b6bec4974b97ee5a50" args="(bool enabled)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a637794857196e7b6bec4974b97ee5a50">Ogre::TangentSpaceCalc::setStoreParityInW</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>enabled</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether to store tangent space parity in the W of a 4-component tangent or not. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The default element format to use is VET_FLOAT3 which is enough to accurately deal with tangents that do not involve any texture coordinate mirroring. If you wish to allow UV mirroring in your model, you must enable 4-component tangents using this method, and the 'w' co-ordinate will be populated with the parity of the triangle (+1 or -1), which will allow you to generate the bitangent properly. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">enable</td><td>true to enable 4-component tangents (default false). If you enable this, you will probably also want to enable mirror splitting (see setSplitMirrored), and your shader must understand how to deal with the parity. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00111">111</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="aac1530e73ac67068755e65063965fe98"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::setVertexData" ref="aac1530e73ac67068755e65063965fe98" args="(VertexData *v_in)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TangentSpaceCalc.html#aac1530e73ac67068755e65063965fe98">Ogre::TangentSpaceCalc::setVertexData</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&#160;</td>
          <td class="paramname"><em>v_in</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the incoming vertex data (which will be modified) </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a7abe610c2dbc8256421979bc6e63ce47"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::mIDataList" ref="a7abe610c2dbc8256421979bc6e63ce47" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a5aa76640242555497cf5decebb2eee97">IndexDataList</a> <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a7abe610c2dbc8256421979bc6e63ce47">Ogre::TangentSpaceCalc::mIDataList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00188">188</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3a17076d70074dabd0884b14efaed6d0"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::mOpTypes" ref="a3a17076d70074dabd0884b14efaed6d0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#a2cab27a58be8085742707d309d52a493">OpTypeList</a> <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a3a17076d70074dabd0884b14efaed6d0">Ogre::TangentSpaceCalc::mOpTypes</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00189">189</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a17e748a306d6e8aa655573f425b1ee98"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::mSplitMirrored" ref="a17e748a306d6e8aa655573f425b1ee98" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a17e748a306d6e8aa655573f425b1ee98">Ogre::TangentSpaceCalc::mSplitMirrored</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00190">190</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a09fcd46e2d234c9c967a394c96ed608c"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::mSplitRotated" ref="a09fcd46e2d234c9c967a394c96ed608c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a09fcd46e2d234c9c967a394c96ed608c">Ogre::TangentSpaceCalc::mSplitRotated</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00191">191</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a648fd36164397e42547bd3758018245d"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::mStoreParityInW" ref="a648fd36164397e42547bd3758018245d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a648fd36164397e42547bd3758018245d">Ogre::TangentSpaceCalc::mStoreParityInW</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00192">192</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="ada66de0f26b1df7521fc8f20dbda4718"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::mVData" ref="ada66de0f26b1df7521fc8f20dbda4718" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* <a class="el" href="classOgre_1_1TangentSpaceCalc.html#ada66de0f26b1df7521fc8f20dbda4718">Ogre::TangentSpaceCalc::mVData</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00185">185</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<a class="anchor" id="a43bd62c359203f882604b685b8a71176"></a><!-- doxytag: member="Ogre::TangentSpaceCalc::mVertexArray" ref="a43bd62c359203f882604b685b8a71176" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TangentSpaceCalc.html#af5204c42a779f3f8a71a8f06b4000d2b">VertexInfoArray</a> <a class="el" href="classOgre_1_1TangentSpaceCalc.html#a43bd62c359203f882604b685b8a71176">Ogre::TangentSpaceCalc::mVertexArray</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTangentSpaceCalc_8h_source.html#l00211">211</a> of file <a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreTangentSpaceCalc_8h_source.html">OgreTangentSpaceCalc.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:09
</p>
</body>
</html>
